#include<stdio.h>
#include<math.h>

//testovaci data
int L;
double S;
int A, B;
int a[22222];
int b[22222];

//reseni
int K;
int check[22222][2];  //check, ze kazdy privoz je s nejakym spojeny
double sum = 0; //celkova delka


double distance(double l, double r)
{
	return sqrt(S*S	+ (l-r)*(l-r) );	
}

//argumenty: 1. soubor s testovacimi daty, 2. soubor s optimalnim souctem delek pro dana testovaci data
//program cte reseni souteziciho na standardnim vstupu
int main(int argc, char** argv)
{
	int i;

	//nacteni testovacich dat
	FILE *f = fopen(argv[1], "r");
	fscanf(f, "%d%lf%d%d", &L, &S, &A, &B);
	for (i = 0; i < A; i++)
		fscanf(f, "%d", a+i);
	for (i = 0; i < B; i++)
		fscanf(f, "%d", b+i);
	fclose(f);

	//nacteni reseni + kontrola formatu resitelova vystupu
	if (scanf("%d", &K) != 1) {
		fprintf (stderr, "Chybny format vystupu.\n");
		return 1;
	}
	for (i = 0; i < K; i++) {
		int l, r;
		if (scanf("%d %d", &l, &r) != 2) {
			fprintf (stderr, "Chybny format vystupu.\n");
			return 1;
		}
		if (l < 1 || l > A || r < 1 || r > B) {
			fprintf (stderr, "Chybny format vystupu.\n");
			return 1;
		}
		check[l-1][0]++;
		check[r-1][1]++;
		sum += distance( (double) a[l-1], (double) b[r-1]);
	}

	//check, zda je kazdy privoz s nejakym spojeny
	for (i = 0; i < A; i++) {
		if (check[i][0] == 0) {
			fprintf (stderr, "Existuje nespojeny privoz.\n");
			return 2;
		}
	}
	for (i = 0; i < B; i++) {
		if (check[i][1] == 0) {
			fprintf (stderr, "Existuje nespojeny privoz.\n");
			return 2;
		}
	}

	//optimality check
	double optimal;
	f = fopen(argv[2], "r");
	fscanf(f, "%lf", &optimal);
	fclose(f);
	double epsilon = 0.01;
	if (sum > optimal + epsilon) {
		fprintf (stderr, "Neoptimalni reseni.\n");
		return 3;
	}

	fprintf (stderr, "OK.\n");
	return 0;
}
